Public Class ThumbViewer	
	Inherits System.Windows.Forms.UserControl

	Dim images As ArrayList = New ArrayList	  ' TlCۑp

	Dim baseSize As Integer = 150	' ێrbg}bṽTCY
	Dim padding As Integer = 2	' Obhł̃TlC̗]

	Dim thumbSize As Integer	' \̃TlC̃TCYi`j
	Dim cols As Integer	' Obh̗
	Dim rows As Integer	' Obh̍s
	Dim gridSize As Integer	' Obh̃TCY
	Dim _selectedIndex As Integer	' ݑIĂTlC

	Dim framePen As Pen	' g\p̃y
	Dim frameErasePen As Pen	' gp̃y

#Region " Windows tH[ fUCiŐꂽR[h "
	Public Sub New()
		MyBase.New()

		' ̌Ăяo Windows tH[ fUCiŕKvłB
		InitializeComponent()

		' InitializeComponent() Ăяǒɏǉ܂B

		' _uobt@Oɂ`̍
		Me.SetStyle(ControlStyles.DoubleBuffer, True)
		Me.SetStyle(ControlStyles.UserPaint, True)
		Me.SetStyle(ControlStyles.AllPaintingInWmPaint, True)

		Me.BackColor = SystemColors.Window

		framePen = New Pen(SystemColors.Highlight, 2)

		' ftHg̃TlC̃TCYݒ
		thumbSize = 64

		' IĂTlCȂ
		_selectedIndex = -1
		updateRowsCols()
	End Sub

	' UserControl1 ́AR|[lgꗗɌ㏈s邽߂ dispose I[o[Ch܂B
	Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
		If disposing Then
			If Not (components Is Nothing) Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(disposing)
	End Sub

	' Windows tH[ fUCiŕKvłB
	Private components As System.ComponentModel.IContainer

	'  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
	'Windows tH[ fUCigĕύXĂB  
	' R[h GfB^gĕύXȂłB
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
		'
		'ThumbViewer
		'
		Me.Name = "ThumbViewer"

	End Sub

#End Region


	Sub updateRowsCols()
		If Me.ClientSize.Width <= 0 Then		  ' ŏȂ	
			Return
		End If

		cols = Me.ClientSize.Width \ (thumbSize + padding * 2)
		If cols = 0 Then
			cols = 1
		End If

		gridSize = Me.ClientSize.Width \ cols

		rows = images.Count \ cols
		If images.Count Mod cols > 0 Then
			rows += 1
		End If

		If thumbSize > gridSize - padding * 2 Then
			thumbSize = gridSize - padding * 2
		End If

		' TlC̕\̈ݒ
		Me.AutoScrollMinSize = New Size(0, rows * gridSize)
	End Sub

	Public Sub Add(ByVal img As Image)
		Dim bmp As Bitmap

		' TlC쐬ăRNVŕێ
		If img.Width > img.Height Then
			bmp = New Bitmap(img, baseSize, baseSize * img.Height \ img.Width)
		Else
			bmp = New Bitmap(img, baseSize * img.Width \ img.Height, baseSize)
		End If
		images.Add(bmp)
		updateRowsCols()

		' ǉꂽTlC\
		Dim g As Graphics = Me.CreateGraphics()
		drawOne(g, images.Count - 1, False)
		g.Dispose()
	End Sub

	' w肳ꂽ̈̒ɉ摜`
	Sub drawImageCenter(ByVal g As Graphics, ByVal image As Image, ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer)
		Dim dw As Double = CDbl(w) / CDbl(image.Width)
		Dim dh As Double = CDbl(h) / CDbl(image.Height)
		Dim scale As Double = Math.Min(dw, dh)

		Dim w2 As Integer = CInt(image.Width * scale)
		Dim h2 As Integer = CInt(image.Height * scale)

		g.DrawImage(image, x + (w - w2) \ 2, y + (h - h2) \ 2, w2, h2)
	End Sub

	' w肳ꂽ̈ɋ``^
	Sub drawFrameRectangle(ByVal g As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal draw As Boolean)
		frameErasePen = New Pen(Me.BackColor, 2)
		Dim p As Pen = CType(IIf(draw, framePen, frameErasePen), Pen)
		g.DrawRectangle(p, x + 2, y + 2, w - 4, h - 4)
		frameErasePen.Dispose()
	End Sub

	' w肳ꂽCfbNXԍ̘g\^
	Sub drawFrame(ByVal g As Graphics, ByVal index As Integer, ByVal draw As Boolean)
		Dim col As Integer = index Mod cols
		Dim row As Integer = index \ cols

		drawFrameRectangle(g, col * gridSize, row * gridSize + Me.AutoScrollPosition.Y, gridSize, gridSize, draw)
	End Sub

	' w肳ꂽCfbNXԍ̃TlC\
	Sub drawOne(ByVal g As Graphics, ByVal index As Integer, ByVal selected As Boolean)
		Dim col As Integer = index Mod cols
		Dim row As Integer = index \ cols

		drawImageCenter(g, CType(images(index), Image), _
		  col * gridSize + (gridSize - thumbSize) \ 2 + padding, _
		  row * gridSize + (gridSize - thumbSize) \ 2 + padding + Me.AutoScrollPosition.Y, _
		  thumbSize - padding * 2, thumbSize - padding * 2)

		If selected Then
			' g\
			drawFrame(g, index, True)
		End If
	End Sub

	' ݑIĂCfbNXԍ̎擾iIF-1j
	Public ReadOnly Property SelectedIndex() As Integer
		Get
			Return _selectedIndex
		End Get
	End Property

	' TlC`悷TCY̐ݒƎ擾
	Public Property ThumbnailSize() As Integer
		Get
			Return thumbSize
		End Get
		Set(ByVal Value As Integer)
			thumbSize = Value
			If images.Count = 0 Then
				Return
			End If

			updateRowsCols()
			Invalidate()
		End Set
	End Property

	' TlC摜Ɖʂ̃NA
	Public Sub Clear()
		For Each img As Image In images
			img.Dispose()
		Next
		images.Clear()
		_selectedIndex = -1

		updateRowsCols()
		Invalidate()
	End Sub

	Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)

		MyBase.OnPaint(e)

		Dim rowStart As Integer = (-Me.AutoScrollPosition.Y + e.ClipRectangle.Y) \ gridSize
		Dim rowEnd As Integer = (-Me.AutoScrollPosition.Y + e.ClipRectangle.Y + e.ClipRectangle.Height) \ gridSize + 1

		Dim i As Integer
		For i = rowStart * cols To Math.Min(rowEnd * cols, images.Count) - 1
			drawOne(e.Graphics, i, i = _selectedIndex)
		Next
	End Sub

	Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
		MyBase.OnResize(e)

		updateRowsCols()
		Me.Invalidate()
	End Sub

	Protected Overrides Sub OnMouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)

		Dim col As Integer = e.X \ gridSize
		Dim row As Integer = (e.Y - Me.AutoScrollPosition.Y) \ gridSize

		Dim newSelected As Integer = row * cols + col

		' TlC݂̑ȂꏊNbNꂽꍇ
		If newSelected > images.Count - 1 Then
			Return
		End If

		' IĂTlCύX
		If Not newSelected = _selectedIndex Then
			Dim g As Graphics = Me.CreateGraphics()
			If Not _selectedIndex = -1 Then
				drawFrame(g, _selectedIndex, False)				'  g
				drawOne(g, _selectedIndex, False)				' gȂŕ`
			End If
			_selectedIndex = newSelected
			drawOne(g, _selectedIndex, True)			 ' gtŕ`
			g.Dispose()
		End If

		' CfbNXύXɃCxgEnhĂяo悤ɂ
		MyBase.OnMouseDown(e)
	End Sub
End Class
